/**<pre>
 * Title: PhoneGUI
 * Copyright: Copyright (c) 2003
 * Company:   University of Oregon Computer Science Dept.
 *
 * @author Jason Prideaux
 * @version 1.0
 * </pre>
 */

package app;

import java.awt.*;
import java.awt.event.*;
import java.util.Date;
import java.io.*;
import java.util.*;



public class PhoneGUI extends Frame{

	Image background;
	Label stat = new Label("");
	Label rcv = new Label("Agents that you can call are blue:");
	Panel panel;

	private PhoneApp parent;



	//Constructs a UI which is used by 'widget' and displays info on 'user'
	public PhoneGUI(PhoneApp parent, String id){

		super("PhoneApp - "+id);
		setSize(240,300);

		this.parent = parent;

		setLocation(0,0);
		setLayout(null);
		//parent = widget;

		this.addWindowListener(new WindowAdapter(){
	  		public void windowClosing(WindowEvent e)
			{
				System.exit(0);
			}
		});


		Toolkit tool = Toolkit.getDefaultToolkit();   //gotta love tool
		try{
			byte[] b = new byte[26000];
			FileInputStream fis = new FileInputStream("files/app/images/ipaq.jpg");
			fis.read(b);

			background = tool.createImage(b);
		}catch(Exception e){}


		panel = new Panel(null);
		//panel.setBounds( 0, 23, 240, 280);
		setSize(370,603);
		panel.setBounds( 63, 161, 240, 280);


		rcv.setBounds( 10,30,220,20 );
		stat.setBounds( 10,260,220,20 );


		panel.add(rcv);
		panel.add(stat);

		add(panel);

		this.setVisible(true);


	} //Constructor



   	/* ====================================================================== */
	/** This
	 *
	 *  @param  g
	 *
	 */
   	public void paint(Graphics g) {

		// paint any space not covered
     	super.paint(g);

      	// If we have a valid width and height for the
       	// background image, draw it.

         g.drawImage(background,0,23,this);

   	} //method: paintComponent



	public void send_actionPerformed(ActionEvent e){
		Button btn = (Button)(e.getSource());
		String id = btn.getName();
		parent.tryPhoneCall(id);

	}

	public void update(HashMap table){

		panel.removeAll();
		panel.add(rcv);
		panel.add(stat);

		java.util.Collection all = table.keySet();
		Object[] objs = all.toArray();

		String id ="";
		boolean call= true;
		for (int i=0; i<objs.length; i++) {
			id = (String)objs[i];
			call = ((Boolean)(table.get( objs[i]))).booleanValue();

			//now draw it
			Label l = new Label(id);
			Button b = new Button("Call "+id);
			b.setName(id);
			l.setBounds( 10,50 + (i*20),100,20 );
			b.setBounds( 110,50 + (i*20),100,20 );
			if(call){
				l.setForeground(Color.blue);
				panel.add(b);
				b.addActionListener(new java.awt.event.ActionListener() {
					public void actionPerformed(ActionEvent e) {
						send_actionPerformed(e);
					}
				});
			}else{
				l.setForeground(Color.red);
			}
			panel.add(l);
		}

	}

	public void setStat(String s){
		stat.setText(s);

	}


} //class: